'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var backendPluginApi = require('@backstage/backend-plugin-api');
var alpha = require('@backstage/plugin-catalog-node/alpha');
var KeycloakOrgEntityProvider = require('./cjs/KeycloakOrgEntityProvider-c7c74e69.cjs.js');
require('@backstage/catalog-model');
require('axios');
require('camelize-ts');
require('query-string');
require('url-join');
require('url-template');
require('lodash');
require('keycloak-js');
require('uuid');
require('@backstage/backend-tasks');

const catalogModuleKeycloakEntityProvider = backendPluginApi.createBackendModule({
  pluginId: "catalog",
  moduleId: "catalog-backend-module-keycloak",
  register(env) {
    env.registerInit({
      deps: {
        catalog: alpha.catalogProcessingExtensionPoint,
        config: backendPluginApi.coreServices.rootConfig,
        logger: backendPluginApi.coreServices.logger,
        scheduler: backendPluginApi.coreServices.scheduler
      },
      async init({ catalog, config, logger, scheduler }) {
        catalog.addEntityProvider(
          KeycloakOrgEntityProvider.KeycloakOrgEntityProvider.fromConfig(config, {
            id: "development",
            logger,
            scheduler
          })
        );
      }
    });
  }
});

exports["default"] = catalogModuleKeycloakEntityProvider;
//# sourceMappingURL=alpha.cjs.js.map
