'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var KeycloakOrgEntityProvider = require('./cjs/KeycloakOrgEntityProvider-c7c74e69.cjs.js');
require('@backstage/catalog-model');
require('axios');
require('camelize-ts');
require('query-string');
require('url-join');
require('url-template');
require('lodash');
require('keycloak-js');
require('uuid');
require('@backstage/backend-tasks');

const dynamicPluginInstaller = {
  kind: "legacy",
  async catalog(builder, env) {
    builder.addEntityProvider(
      KeycloakOrgEntityProvider.KeycloakOrgEntityProvider.fromConfig(env.config, {
        id: "development",
        logger: env.logger,
        schedule: env.scheduler.createScheduledTaskRunner({
          frequency: { hours: 1 },
          timeout: { minutes: 50 },
          initialDelay: { seconds: 15 }
        }),
        scheduler: env.scheduler
      })
    );
  }
};

exports.KeycloakOrgEntityProvider = KeycloakOrgEntityProvider.KeycloakOrgEntityProvider;
exports.noopGroupTransformer = KeycloakOrgEntityProvider.noopGroupTransformer;
exports.noopUserTransformer = KeycloakOrgEntityProvider.noopUserTransformer;
exports.sanitizeEmailTransformer = KeycloakOrgEntityProvider.sanitizeEmailTransformer;
exports.dynamicPluginInstaller = dynamicPluginInstaller;
//# sourceMappingURL=index.cjs.js.map
