'use strict';

var KeycloakOrgEntityProvider = require('./cjs/KeycloakOrgEntityProvider-Bp6QW9Pi.cjs.js');
require('@backstage/catalog-model');
require('@keycloak/keycloak-admin-client');
require('lodash');
require('uuid');
require('@backstage/backend-tasks');

const dynamicPluginInstaller = {
  kind: "legacy",
  async catalog(builder, env) {
    builder.addEntityProvider(
      KeycloakOrgEntityProvider.KeycloakOrgEntityProvider.fromConfig(env.config, {
        id: "development",
        logger: env.logger,
        schedule: env.scheduler.createScheduledTaskRunner({
          frequency: { hours: 1 },
          timeout: { minutes: 50 },
          initialDelay: { seconds: 15 }
        }),
        scheduler: env.scheduler
      })
    );
  }
};

exports.KeycloakOrgEntityProvider = KeycloakOrgEntityProvider.KeycloakOrgEntityProvider;
exports.noopGroupTransformer = KeycloakOrgEntityProvider.noopGroupTransformer;
exports.noopUserTransformer = KeycloakOrgEntityProvider.noopUserTransformer;
exports.sanitizeEmailTransformer = KeycloakOrgEntityProvider.sanitizeEmailTransformer;
exports.dynamicPluginInstaller = dynamicPluginInstaller;
//# sourceMappingURL=index.cjs.js.map
